/*************************************************
* TQEditor
* Author      : TengQiu Li
* E-Mail      : litqqs@163.com
* Copyright   : TengQiu Li
* Version     : 2.0.0 beta2
* Site        : http://www.e512.net
*************************************************/
var ua = navigator.userAgent.toLowerCase();
var isIE =!!window.ActiveXObject; //ie  // ua.indexOf('trident')>=0 || ua.indexOf('msie 6')>=0 ; 
var isIE6 = isIE && !window.XMLHttpRequest;//ie6
var isIE9 = isIE && !!document.createDocumentFragment;
var isWebkit = ua.indexOf('webkit')>=0; //chrome,safari
var isOpera = ua.indexOf('presto')>=0; //opera
var isGecko = !isWebkit && ua.indexOf('gecko')>=0; //firefox

function TQE(objId,userConfig)
{
	var $=this;
	$.objId = objId;
	var config=TQE.clone(TQE.config);
	if(userConfig){
		for(var k in userConfig){
			config[k] = userConfig[k];
		}
	};

	if(typeof config.toolbar =='string'){
		var tm=TQE.toolbarMode[config.toolbar];
		if(!tm) tm=TQE.toolbarMode.normal;
		config.toolbar=tm.left;
		if(!userConfig || 'undefined'===typeof userConfig.toolbarRight)config.toolbarRight=tm.right;
	};

	$.config = config;

	$._containerDiv=null;
	$._toolbarDiv=null;
	$._clientDiv=null;
	//Methods
	$.init=function(){
		$.obj = TQE.find(objId);
		if($.obj.editor) return;//已执行过
		$.obj.editor = $;

		if (!$.config.width || $.config.width == "auto") {
			if($.obj.style.width){$.config.width = $.obj.style.width; }
			else if($.obj.cols){ $.config.width = ($.obj.cols * 8)+'px'; }
			else{ $.config.width = '100%'; }
		}
		if (!$.config.height || config.height == "auto") {
			if($.obj.style.height){ $.config.height = $.obj.style.height; }
			else if($.obj.rows){ $.config.height = ($.obj.rows * 17)+'px' }
			else{ $.config.height = '200'; }
		}

		//toolbar
		var code ='<div class="eToolBar" id="'+$.objId+'_EditorToolBar">';
		//
		if($.config.toolbarRight.length){
			code +='<ul class="eToolBarGroupRight" >';
			for(var i=0; i < $.config.toolbarRight.length; i++){
				code += $._btnCode($.config.toolbarRight[i], false);
			}
			code +='</ul>';
		}
		//工具组
		code +='<ul class="eToolBarGroup" >';
		if($.config.showToolbarGroupHandle){
			var btn = TQE.toolbarBottons['group'];
			code +='<div class="eButton"  style="background-position: -'+btn.left+'px 0;width:'+btn.width+'px;" ></div>';
		}
		for(var i=0; i < $.config.toolbar.length; i++){
			code += $._btnCode($.config.toolbar[i], true);
		}
		code +='</ul>';
		//工具组完
		code +='</div>';
		//编辑区
		code +='<div id="'+$.objId+'_EditorClient">';
		code +='<iframe class="eEditorClient" id="'+$.objId+'_Editor" style="height:'+$.config.height+';" frameborder=0 ></iframe>';
		code +='</div>';

		if (!$.config.debug) {
			$.obj.style.display = "none";
		}
		var e =TQE.CE('DIV');
		e.id=	$.objId+'_EditorContainer';
		e.className='eEditor';
		e.style.width=$.config.width;
		e.innerHTML=code;
		$.obj.parentNode.insertBefore(e, $.obj);

		$._containerDiv = e;
		$._toolbarDiv = TQE.find($.objId+'_EditorToolBar');
		$._clientDiv = TQE.find($.objId+'_EditorClient');

		TQE._noSel($._toolbarDiv);
		//TQE._noSel($._toolbarDiv,'DIV,UL,LI');

		var btns = TQE._tags($._toolbarDiv,'LI');
		for(var i=btns.length-1;i>=0;i--){
			$._ieMouseStyle(btns[i],'eButton','eButtonUp','eButtonDown');	//ie6

			TQE.addListener(btns[i],'click',	$._toolbarBottonClick);
			TQE.addListener(btns[i],'mouseout',	function(){
					var o=TQE.activePop;
					this.className=	(o && o.relateObj==this)? 'eButtonDropDown':'eButton';
					});
		}
		if(isIE){//IE6或IE8兼容模式时需要
			var groups = TQE._tags($._toolbarDiv,'UL');
			for(var i=groups.length-1;i>=0;i--){
				var w=3;
				var btns=groups[i].childNodes;
				for(var j=btns.length-1;j>=0;j--){w += btns[j].offsetWidth+2;}
				groups[i].style.width=w+'px';
			}
		}
		//--
		$.setContent($.obj.value);
		$._changed();
		$.obj.focus = function(){this.editor.focus();}
	};
	$._btnCode=function(tn, groupFlag){
		if('||'===tn) tn='group';
		else if('|'===tn) tn='separator';
		var btn = TQE.toolbarBottons[tn];
		if(!btn) return '';
		var styleCode=function(btn){return 'class="eButton" style="background-position: -'+btn.left+'px 0;width:'+btn.width+'px;"'; };
		switch(tn){
			case 'group':
				if(!groupFlag) return '';
				var code='</ul><ul class="eToolBarGroup" >';
				if($.config.showToolbarGroupHandle){
					code+= '<div '+styleCode(btn)+' ></div>';
				}
				return code;
			case 'separator':
				return '<div '+styleCode(btn)+' ></div>';
			default:
				return'<li id="'+$.objId+'_'+tn+'" name="'+tn+'" title="'+btn.text+'" '+styleCode(btn)+' ></li>';
		}
	};
	//ie6
	$._ieMouseStyle=function(obj,normal,hover,down){
		if(!isIE || !isIE6 && document.compatMode == "CSS1Compat") return;
		TQE.addListener(obj,'mouseover',	function(){this.className=hover;});
		TQE.addListener(obj,'mouseup',	function(){this.className=hover;});
		TQE.addListener(obj,'mousedown',	function(){this.className=down;});
		TQE.addListener(obj,'mouseout',	function(){this.className=normal;});
	};
	$._keepBookmark=function(){
		if(isIE){
			var _bookmark;
			var win = TQE.find($.objId+'_Editor');
			TQE.addListener(win,'beforedeactivate',function(){_bookmark=$._getRange();});
			TQE.addListener(win,'activate',function(){
				if(null==_bookmark) return;
				var sel=$._getSelection();
				if(sel.addRange) sel.addRange(_bookmark);
				else _bookmark.select();
				_bookmark=null;
			});
		}
		$._hook();
	};
	$._toolbarBottonClick=function(){
		var e=isIE ? event : arguments[0];
		e.cancelBubble = true;
		var cmd = this.getAttribute('name');
		$.focus();
		var btn=TQE.toolbarBottons[cmd];
		if(btn && btn.click){
			btn.click($,this);
		}else{
			TQE.hidePop();
			$.exeCmd(cmd);
		}
	};
	$.__selectOption=function(selectObj,value){
		for(var i=selectObj.options.length-1;i>=0;i--){
			if(selectObj.options[i].value==value){
				selectObj.selectedIndex=i;
				return;
			}
		}
	};
	$.exeCmd=function(cmd,para){
		$.focus();
		try{$._getDoc().execCommand(cmd,false, para!=null?para:false);}catch(e){}
	};
	$.focus=function(){
		if('visual'==$.currentMode()){
			$._editorObj().contentWindow.focus();
		}else{
			$._editorObj().focus();
		}
	};
	$.focusNode=function(){
		if('visual'!==$.currentMode()) return null;
		var node = $._getSelection().focusNode;
		if(!node){//ie6,7,8 
			var r = $._getRange();
			return (r.length)? r.item(0).parentNode : r.parentElement();
		}
		return node;
	};
	$._showColorSelectUI=function(sender,cmd){
		var o=TQE.find($.objId+'ColorSelect'+cmd);
		if(null==o){
			o = TQE.CE('DIV',$.objId+'ColorSelect'+cmd, TQE._colorPickerUI() ,true);
			o.className='ePopPanel';
			TQE._noSel(o);//,'TABLE,TR,TD,DIV');
			TQE.listenTags(o,'TD','click',function(){TQE.hidePop();$.exeCmd(cmd, this.bgColor);});
			o.lastChild.lastChild.onclick=function(){TQE.hidePop();$.exeCmd(cmd, '');};

			TQE.listenTags(o,'TD','mouseover',function(){
				var p=this.parentNode.parentNode.parentNode.parentNode.lastChild;
				p.firstChild.style.backgroundColor=this.bgColor;
				p.firstChild.nextSibling.innerHTML=this.bgColor;

				this.style.backgroundColor='#FFFFFF';
				var self=this;
				var iid = window.setInterval(function(){self.style.backgroundColor=(self.style.backgroundColor!='')?'':'#FFFFFF'},500);
				this.onmouseout=function(){window.clearInterval(iid);this.style.backgroundColor='';}
			});
		}
		TQE.pop(o,sender);
	};
	$._popAsMenu=function(sender, btns){
		var cmd=sender.getAttribute('name');
		var o=TQE.find($.objId+'PopMenu'+cmd);
		if(null==o){
			o = TQE.CE('DIV',$.objId+'PopMenu'+cmd, '' ,true);
			o.className='ePopPanel';
		}
		var s='';
		for(var i=0; i < btns.length; i++){
			var tn = btns[i];
			if('separator'==tn || '|'==tn){
				s +='<hr style="width:120px; clear:both;" />';
				continue;
			}
			var btn = TQE.toolbarBottons[tn];
			if(btn){
				s +='<div id="'+$.objId+'_'+tn+'" name="'+tn+'" class="eMenuItem" ><span class="eButton" style="background-position: -'+btn.left+'px 0;width:'+btn.width+'px;" ></span>'+btn.text+'</div>';
			}
		}
		o.innerHTML=s;
		TQE._noSel(o);
		if(isOpera)TQE._noSel(o,'DIV');
		TQE.listenTags(o,'DIV','click',$._toolbarBottonClick);
		if(isIE6){ 
			var es = TQE._tags(o,'DIV');
			for(var i=es.length-1;i>=0;i--){
				$._ieMouseStyle(es[i],'eMenuItem','eMenuItemUp','eMenuItem');
			}
		}
		TQE.pop(o,sender);
	};
	$._uploadBtn=function(url,fileTypes,mutilFiles){
		return '<button  type="button" value="上传" id="uploadBtn" name="uploadBtn"  class="eBtn" >上传</button>';
	};
	$._popFormUI=function(id, caption, htm, cbOK, intInputNames, uploadUrl, uploadFileTypes, uploadFileSize, isImage){
		var s='<form  class="ePopForm">';
		if(uploadUrl){
			s+='<div class="eTabBar"><a href="javascript:void(0)" class="active" HIDEFOCUS="true">'+caption+'</a><a href="javascript:void(0)" HIDEFOCUS="true">上传</a></div>';
			s+='<div>';
		}
		s += htm;
		s+='<div class="eBar"><button  id="OK"  name="OK"  type="button" class="eBtn"  HIDEFOCUS="true"/>确定</button> &nbsp; <button id="Cancel" name="Cancel" type="button" class="eBtn"  HIDEFOCUS="true">取消</button></div>';
		if(uploadUrl){
			s+='</div><div style="display:none">';
			var url=uploadUrl;
			if(uploadUrl.substr(0,1)=='#'){//自定上传界面
				url=uploadUrl.substring(1);
			}else{
				//修正相对网址
				if(!('http://'==uploadUrl.substr(0,7).toLowerCase() || '/'==uploadUrl.substr(0,1) || 'https://'==uploadUrl.substr(0,6).toLowerCase())){
					if('?'==uploadUrl.substr(0,1)){
						uploadUrl = location.pathname+uploadUrl;
					}else{
						var a=location.pathname.split('/');
						a[a.length-1]= uploadUrl;
						uploadUrl = a.join('/');
					}
				}
				url=TQE.url+'upload.htm?url='+encodeURIComponent(uploadUrl)+'&field_name='+$.config.uploadFieldName+'&exts='+encodeURIComponent(uploadFileTypes)+'&max_size='+encodeURIComponent(uploadFileSize)+'&debug='+$.config.debug+'&is_image='+isImage;
			}
			s+='<iframe src="'+url+'" frameborder=0 width=358 height=45 ALLOWTRANSPARENCY=true ></iframe>';
			s+='</div>';
		}
		
		s +='</form>';

		var o= TQE.CE('DIV',id, s ,true);
		o.className='ePopPanel';

		if(uploadUrl){
			var tabClick=function(){
				this.className='active';
				if(this.nextSibling){
					this.nextSibling.className='';
					this.parentNode.nextSibling.style.display='';
					this.parentNode.nextSibling.nextSibling.style.display='none';
				}else if(this.previousSibling){
					this.previousSibling.className='';
					this.parentNode.nextSibling.style.display='none';
					this.parentNode.nextSibling.nextSibling.style.display='';
				}
			};
			var tabbar = o.firstChild.firstChild;
			tabbar.firstChild.onclick=tabClick;
			tabbar.lastChild.onclick=tabClick;
		}
		var f= TQE._tags(o,'FORM')[0];
		f.srcEditor=$;
		var es = f.elements;
		es['Cancel'].onclick= TQE.hidePop;
		es['OK'].onclick=cbOK;
		if(intInputNames) for(i=intInputNames.length-1;i>=0;i--) $._intEdit(es[intInputNames[i]]);
		TQE._noSel(o);
		if(isOpera)TQE._noSel(o,'FORM,DIV');
		return o;
	};
	$.insertMusic=function(url,auto_start){
		var s = $.config.tplMusic.replace(/\{\$url\}/g,url).replace(/\{\$auto_start\}/g,auto_start);
		$.insertHtml(s);
	};
	$.insertFlash=function(url,width,height){
		var s = $.config.tplFlash.replace(/\{\$url\}/g,url);
		s = s.replace(/\{\$width\}/g,width);
		s = s.replace(/\{\$height\}/g,height);
		$.insertHtml(s);
	};
	$.insertVideo=function(url,auto_start,width,height,video_type){
		var tpl='';
		switch(video_type){
			case 'rm':tpl = $.config.tplRm;break;
			case 'flv':tpl = $.config.tplFlv;break;
			case 'wm':tpl = $.config.tplVideo;break;
			default:
				var ext = url.substr(url.lastIndexOf('.')).toLowerCase();
				if('.flv'==ext){
					tpl = $.config.tplFlv;
				}else if('.rm'==ext || '.rmvb'==ext){
					tpl = $.config.tplRm;
				}else{
					tpl = $.config.tplVideo;
				}
			break;
		}
		tpl = tpl.replace(/\{\$url\}/g,url).replace(/\{\$auto_start\}/g,auto_start).replace(/\{\$width\}/g,width).replace(/\{\$height\}/g,height);
		$.insertHtml(tpl);
	};
	//position 可选值[before|after|replace|-1|1|0]
	$.insertHtml=function(htm,position){
		if(isGecko){
			htm = htm.replace(/<td([^>]*)>\s*<\/td/ig, '<td$1 ><br></td');
		}
		$.focus();
		var r = $._getRange();
		if(r.length){  //ie
			var d=$._getDoc();
			var e=r.item(0);
			var tr=d.body.createTextRange();
			tr.moveToElementText(e);
			if('before'==position || -1==position){
				tr.collapse();
			}else if('after'==position || 1==position){
				tr.collapse(false);
			}else{
				r.execCommand('Delete');
			}
			tr.pasteHTML(htm);
			tr.select();//重设光标
		}else if(r.insertNode){
			var cf;
			if(r.createContextualFragment){//IE9 未实现此方法
				cf=r.createContextualFragment(htm);
			}else{
				cf =$._getDoc().createDocumentFragment();
				cf.appendChild(TQE.CE('div'));
				cf.firstChild.outerHTML=htm;
			}

			if('before'==position || -1==position){
				var n= cf.lastChild;
				r.insertNode(cf);
				r.setEndAfter(n);
			}else if('after'==position || 1==position){
				r.collapse(false);
				r.insertNode(cf);
			}else{
				r.deleteContents();
				r.insertNode(cf);
			}
			r.collapse(false);
			var sel	= $._getSelection();
			sel.removeAllRanges();
			sel.addRange(r);
		}else{
			if('before'==position || -1==position){
				r.collapse(true);
			}else if('after'==position || 1==position){
				r.collapse(false);
			}
			r.pasteHTML(htm);
			r.collapse(false);
			r.select();
		}
	};
	$._editorObj= function(){
		return  TQE.find($.objId+'_Editor');
	};
	$.currentMode=function(){//取得当前的编辑模式, code 代码 , visual 可视化
		return ($._editorObj().tagName.toUpperCase()=='IFRAME')?'visual':'code';
	};
	$._getDoc=function(){
		var iframe =$._editorObj();
		return iframe.contentDocument || iframe.contentWindow.document;
	};
	$._getSelection=function(){
		var win =$._editorObj().contentWindow;
		return (win.getSelection) ? win.getSelection() : $._getDoc().selection;
	};
	$._getRange=function(){
		var selection=$._getSelection(), d=$._getDoc(),r;
		try{//标准dom
			r = selection.rangeCount > 0 ? selection.getRangeAt(0) : (selection.createRange ? selection.createRange() : d.createRange());
		}catch (e){}
		if(!r) r = isIE ? d.body.createTextRange() : d.createRange();
		return r;
	};
	$.insertImage=function(image_url,width,height,border,alt,align){
		if(''==image_url) return;
		var s='<img src="'+image_url+'" ';
		if(width!=undefined && ''!=width && !isNaN(parseInt(width)) && parseInt(width)>0 ) s += ' width='+parseInt(width);
		if(height!=undefined && ''!=height && !isNaN(parseInt(height)) && parseInt(height)>0 ) s +=' height='+parseInt(height);
		if(border!=undefined && ''!=border && !isNaN(parseInt(border))) s +=' border='+parseInt(border);
		if(alt!=undefined && ''!=alt) s +=' alt="'+alt+'"';
		if(align!=undefined && ''!=align) s +=' align="'+align+'"';
		s +=' />';
		$.insertHtml(s); 
		return;
	};
	$._enableButton=function(btn,enable){
		if(enable){
			btn.disabled=false;
			$.setOpacity(btn,100);
			TQE.addListener(btn,'click',$._toolbarBottonClick);
		}else{
			btn.disabled=true;
			$.setOpacity(btn,30);
			TQE.delListener(btn,'click',$._toolbarBottonClick);
		}
	};
	$._updateToolbar=function(enable, buttons, exceptFlag){
		var tb=$._toolbarDiv;
		var btns = TQE._tags(tb,'LI');
		for(var i=btns.length-1;i>=0;i--){
			if($.inArray(btns[i].getAttribute('name'), buttons) ^ exceptFlag  ) {
				$._enableButton(btns[i],enable);
			}
		}
	};
	$._hook=function(){
		if('visual'!=$.currentMode()) return; //!isIE || !$.config.enter2br || 
		var doc=$._getDoc();
		doc.onkeydown = function(e){
			TQE._hideContext();
			if(isIE) e = $._editorObj().contentWindow.event;
			var key = e.keyCode || e.which;
			if(key==13){
				//var r= $._getRange();
				var o = $.focusNode();//r.parentElement ? r.parentElement():r.commonAncestorContainer.parentNode;
				if(o.className == 'splitPage'){//分页标题
					var p=o.parentNode;
					var br = document.createElement('BR');
					if(p.lastChild == o){
						p.appendChild(br);
					}else{
						p.insertBefore(br,o.nextSibling);
					}
					//重设光标
					var d=$._getDoc(), tr;
					if(isIE){
						tr=d.body.createTextRange();
						tr.moveToElementText(br)
						tr.collapse(true);
						tr.select();
					}else{	
						tr = d.createRange();
						tr.selectNode(br);
						tr.collapse(true);
						var sel	= $._getSelection();
						sel.removeAllRanges();
						sel.addRange(tr);
					}
					return false;
				}
				//--
				//if(e.shiftKey){e.shiftKey=false;return true;}
				if($.config.enter2br){
					if(o.tagName != 'LI'){
						$.insertHtml('<br />');
						return false;
					}
				}
			}
		};
		doc.ondragstart=function(e){TQE._hideContext();};
		doc.onclick=function(e){
			TQE._hideContext();
			$.focus();
			if(!isIE){
				if(e.target.tagName=='IMG'){
					var r = $._getDoc().createRange();
					r.selectNode(e.target);
					var sel	= $._getSelection();
					sel.removeAllRanges();
					sel.addRange(r);
					$._popImgContextPanel(e.target);
				}
			}else{
				e=$._editorObj().contentWindow.event;
				if(e.srcElement.tagName=='IMG'){
					$._popImgContextPanel(e.srcElement);
				}
			}
		};

		if(isIE){
			doc.onmousedown=doc.onclick;
			doc.onclick=null;
		}
		//doc.oncontextmenu=function(e){
		//	var sel = $._getSelection();
		//	if(! sel.isCollapsed) return true; //有选择内容时使用默认的右键菜单
		//	return true;
		//};
	};
	$._popImgContextPanel=function(img){
		var o=TQE.find('__tqImgContextPanel');
		if(null==o){
			var s='<form class="ePopForm">网址: <input type="text" id="url" size="50"><br>尺寸: <input  type="text" id="width" style="width:30px; overflow:visible;"> &times; <input  type="text" id="height" style="width:30px; overflow:visible;">px <a href="javascript:void(0)" id="resetWH" >重设大小</a><label><input name="lock" type="checkbox" id="lock" value="1" checked>锁定比例</label><br>排版: <a href="javascript:void(0)" id="alignDefault">默认</a> | <a href="javascript:void(0)" id="alignLeft">左浮动</a> | <a href="javascript:void(0)" id="alignC">居中</a> | <a href="javascript:void(0)" id="alignRight">右浮动</a> | <a href="javascript:void(0)" id="alignTop">上对齐</a> | <a href="javascript:void(0)" id="alignAbsMiddle">中对齐</a> | <a href="javascript:void(0)" id="alignBottom">下对齐</a></form>';
			o= TQE.CE('DIV','__tqImgContextPanel', s ,true);
			o.className='ePopPanel';
			var f= TQE._tags(o,'FORM')[0];
			var es = f.elements;
			$._intEdit(es['width']);
			$._intEdit(es['height']);

			o.urlField=es['url'];
			o.widthField=es['width'];
			o.heightField=es['height'];
			o.lockField=es['lock'];

			o.urlField.onchange=function(){
				this.parentNode.parentNode.target.src=this.value;;
			};
			o.urlField.onfocus=function(){this.select();};
			var setwh=function(){
				var o=this.parentNode.parentNode, w=h=Math.max(1,this.value);
				if(o.lockField.checked){
					if(this.id=='width') h=o.heightField.value=Math.round(w/ o.rate);
					else w=o.widthField.value=Math.round(h * o.rate);
				}else{
					if(this.id=='width') h=o.heightField.value;
					else w=o.widthField.value;
				}
				o.target.width=w;
				o.target.height=h;
				o.target.style.width='';
				o.target.style.height='';
			};
			o.widthField.onchange=o.widthField.onblur=o.heightField.onchange=o.heightField.onblur=setwh;

			o.lockField.onclick=function(){
				if(this.checked){
					var o=this.parentNode.parentNode.parentNode; 
					o.rate=o.widthField.value/o.heightField.value;
				}
			};

			var aClick=function(e){
				var op=this.parentNode.parentNode;
				var o=op.target;
				var id=this.id;
				if('resetWH'==id){
					o.removeAttribute('width');
					o.removeAttribute('height');
					o.style.width='';
					o.style.height='';
					op.widthField.value=o.width;
					op.heightField.value=o.height;
					op.rate=o.width/o.height;
				}else{ // if('align'==id.substring(0,5)){
					o.align='';
					o.style.display='';
					o.style.margin='';
					$.exeCmd('justifynone');
					if('alignC'==id){
						//o.style.display='block';
						//o.style.margin='5px auto';
						$.exeCmd('justifycenter');
					}else if('alignDefault'!=id){
						o.align=id.substring(5,20).toLowerCase();;
					}
				}
				return false;
			};
			var os = TQE._tags(o,'A');
			for(var i=os.length-1;i>=0;i--){
				os[i].onclick=aClick;
			}
			TQE._noSel(o);
		}
		o.target=img;
		o.urlField.value=img.getAttribute('src');
		o.widthField.value=img.width;
		o.heightField.value=img.height;
		o.rate= (img.width>0 && img.height>0) ? img.width / img.height:1;
		$._popContext(o, img);
	};
	$._popContext=function(o,relateObj){
		if(TQE.activeContext != o )TQE._hideContext();
		var x,y,p=TQE.pos($._editorObj()),p2=relateObj.getBoundingClientRect();
		var d=TQE._doc;

		o.style.display="block";
		x = Math.min( p.x+ p2.left , TQE._docScrollLeft() + d.clientWidth-o.offsetWidth-5);
		y =  10+p.y+ p2.bottom;
		var my=	TQE._docScrollTop() + d.clientHeight - o.offsetHeight-10; 
		if(y > my) y=p2.top+p.y-o.offsetHeight-10;
		if(y<TQE._docScrollTop())y=10+Math.max(p.y, TQE._docScrollTop());//	isIE? window.event.clientY : 
		o.style.left= x+'px';
		o.style.top= y+'px';
		TQE.activeContext=o;
		TQE.drag(o);
	};
	$._popTableContext=function(){
		var id='tableContextPanel';
		var o=TQE.find(id);
		if(!o){
			var btn = TQE.toolbarBottons['inserttable'];
			var s ='<form class="ePopForm"><span class="eButton" style="background-position: -'+btn.left+'px 0;width:'+btn.width+'px;" ></span>表格属性<br />背景色:<input name="bgcolor" type="text" id="bgcolor" value="" size="7" />边框色:<input name="bordercolor" type="text" id="bordercolor" value="" size="7" /><br />宽度:<input name="width" type="text" id="width" value="100%" size="5" />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  填充:<input name="cellpadding" type="text" id="cellpadding" value="3" size="5" /><br>对齐: <a href="#">默认</a> | <a href="#">左</a> | <a href="#">中</a> | <a href="#">右</a></form>';
			o = TQE.CE('DIV',id, s ,true);
			o.className='eTableContextPanel';
			o.style.width='20px';
			o.style.height='20px';
			o.style.overflow='hidden';
			o.style.border='none';
		}
		//working

	};
	$._changed=function(){
		$._autoSave();
		var o;
		if('visual'==$.currentMode()){
			var doc = $._getDoc();
			TQE.addListener(doc,'mouseup',TQE.hidePop);
			$._keepBookmark();
			if($.config.autoClean) doc.body.onpaste=function(){setTimeout($.cleanWord,200);};
			o=$._editorObj().contentWindow;
		}else{
			o= $._editorObj();
			TQE.addListener(o,'mouseup',TQE.hidePop);
		}
		//绑定事件
		o.onfocus=function(){if($.obj.onfocus) $.obj.onfocus();};
		o.onblur=function(){if($.obj.onblur) $.obj.onblur();};
	};
	//mode 可选值[code|visual]
	$.changeMode=function(mode){//更改编辑方式,空值时自动转另一种方式
		var old=$.currentMode();
		if(old===mode) return;
		if(!mode){
			 mode = ('code'!=old) ? 'code' : 'visual';
		}
		if(mode==old) return;
		var e,eo=$._editorObj();
		if('code'===mode){
			e = TQE.CE('TEXTAREA');
			e.style.width= (eo.offsetWidth-4)+'px';
			e.style.height= (eo.offsetHeight-5)+'px';
		}
		else if('visual'===mode){
			e = TQE.CE('IFRAME');
			e.frameBorder=0;
 			e.style.height=eo.offsetHeight-1+'px';
		}else{
			return;
		}
		e.className='eEditorClient';
		var code = $.content('code'===mode && $.config.formatHTML);
		$._clientDiv.innerHTML='';
		e.id=$.objId+'_Editor';

		$._clientDiv.appendChild(e);
		$.setContent(code);
		$._changed();
		$._hook();
		TQE._hideContext();
		$._updateToolbar('visual'===mode,['mode','fullscreen','help'], true);
	};
	//自动排版
	$.typeset=function(){
		if('visual'!=$.currentMode()) return;
		var d = $._getDoc(),e,es,s,div,ep;
		//删除不必要的空格,将DIV转为P
		s=d.body.innerHTML;
		s=s.replace(/&nbsp;/gi,' ').replace(/>\s+</gm,'><').replace(/ +/gi,' ').replace(/<div/gi,'<p').replace(/<\/div/gi,'</p');
		d.body.innerHTML=s;
		//删除不必要的SPAN
		es=TQE._tags(d,'SPAN');
		for(i=es.length-1;i>=0;i--){
			e=es[i];
			var fw=	e.style.fontWeight,c=e.style.color;
			if(''===e.innerHTML.replace(/<[a-z\/][^>]*>/gi,'') || ( fw=='' && c=='')){
				TQE.removeNode(e,false);
				continue;
			}
			e.removeAttribute('style');
			e.style.fontWeight=fw;
			e.style.color=c;
		}
		//清理段落
		es=TQE._tags(d,'P');
		var emtpyReg=/^(&nbsp;| ){3,}/
		for(i=es.length-1;i>=0;i--){
			e=es[i];
			if(''==e.innerHTML.replace(/<[a-z\/][^>]*>/gi,'').replace( /( |\n|\r|\t|&nbsp;)/gi, '')){//删除空白的段落
				TQE.removeNode(e,false);
				continue;
			} 
			e.removeAttribute('style');
			if(emtpyReg.test(e.innerHTML)){
				e.align='center';
			}else{
				e.removeAttribute('align');
				e.style.textIndent=$.config.typesetIndentParagraph ? '2em':'';
			}
		}
		//排版图片下方的文字
		var centerImageText=function(node){
			while(node && node.tagName!='BODY'){
				if(node.nextSibling){
					var ne=node.nextSibling,s;
					if(ne.nodeName==='#text'){
						s=ne.nodeValue;
						s=s.replace( /( |\n|\r|\t|&nbsp;)/gi, '');
						if(''!=s){
							div = TQE.CE('CENTER','',ne.nodeValue);
							//div.style.textAlign='center';
							node.parentNode.insertBefore(div,ne);
							TQE.removeNode(ne,true);
							return ;
						}
					}else{
						s=ne.innerHTML.replace(/<[a-z\/][^>]*>/gi,'').replace(/(\s|&nbsp;)/gmi,'');
						if(s!=''){
							if(ne.tagName=='CENTER') return;
							if(ne.tagName=='P') ne.align='center';
							else ne.style.textAlign='center';
							return ;
						}
					}
				}
				node=node.parentNode;
			}
		};
		//排版图片
		es=TQE._tags(d,'IMG');
		for(i=es.length-1;i>=0;i--){
			e=es[i];
			if($.config.typesetImageTextCenter)centerImageText(e);
			e.removeAttribute('style');
			e.border= $.config.typesetImageBorder ? '1':'0';
			e.style.margin='5px';
			//e.style.margin='5px auto';
			//e.style.display='block';

			ep=e.parentNode;
			if(ep.tagName=='A' && ep.firstChild==ep.lastChild){
				e=ep;
				ep=ep.parentNode;
			}
			if(ep.tagName=='P' && ep.align=='center' || ep.tagName=='CENTER' || ep.style.textAlign=='center') continue;
			div = TQE.CE('CENTER');
			ep.insertBefore(div, e);
			div.appendChild(e);
		}
		//排版视频,flash等
		es=TQE._tags(d,'OBJECT');
		for(i=es.length-1;i>=0;i--){
			e=es[i];
			if($.config.typesetImageTextCenter)centerImageText(e);

			ep=e.parentNode;
			if(ep.tagName=='P' && ep.align=='center' || ep.tagName=='CENTER' || ep.style.textAlign=='center') continue;
			div = TQE.CE('CENTER');
			ep.insertBefore(div, e);
			div.appendChild(e);
		}
		//排版视频,flash等
		es=TQE._tags(d,'EMBED');
		for(i=es.length-1;i>=0;i--){
			e=es[i];
			if('OBJECT'===e.parentNode.tagName) continue;
			if($.config.typesetImageTextCenter) centerImageText(e);

			ep=e.parentNode;
			if(ep.tagName=='P' && ep.align=='center' || ep.tagName=='CENTER' || ep.style.textAlign=='center') continue;
			div = TQE.CE('CENTER');
			ep.insertBefore(div, e);
			div.appendChild(e);
		}
	};
	//force	布尔值
	$.cleanWord=function(force){
		if('visual'!=$.currentMode()) return;
		var d = $._getDoc(),e,es,s;
		if(!force){
			if(d.body.innerHTML.indexOf('mso') <0) return;
		}
		var cleanTag=function(tag, removeOnEmptyStyle){
			var es=TQE._tags(d,tag);
			for(i=es.length-1;i>=0;i--){
				e=es[i];
				e.removeAttribute('lang');
				s = e.getAttribute('style');
				if(null==s && removeOnEmptyStyle){
					TQE.removeNode(e,false);
					continue;
				}
				if(typeof s =='string' && s.indexOf('mso-')>=0){
					s+=';';
					s=s.replace(/mso\-[^;]+?;/gi,'');
					s=s.replace(/FONT\-FAMILY[^;]+?;/gi,'');
					s=s.replace(/\s+/g,' ');
					s=s.replace(/MARGIN\: 0cm 0cm 0pt/gi,'');
					if(''==s || ' '==s){
						if(removeOnEmptyStyle){
							TQE.removeNode(e,false);
							continue;
						}
						e.removeAttribute('style');
					}else{
						e.setAttribute('style',s);
					}
				}
				s = e.getAttribute('class');
				if(null!=s){
					s=s.replace(/mso[a-z\-]+\s*/gi,'');
					if(''==s){
						e.removeAttribute('class');
					}else{
						e.setAttribute('class',s);
					}
				}
			}
		};
		cleanTag('SPAN',true);
		cleanTag('P',false);
		cleanTag('B',false);
		cleanTag('I',false);
		cleanTag('U',false);
		cleanTag('TD',false);
		cleanTag('TR',false);
		cleanTag('TABLE',false);
		cleanTag('DIV',false);

		s=d.body.innerHTML;
		s=s.replace(/<o:[a-z0-9_]+[^>]*>/gi,'').replace(/<\/o:[a-z0-9_]+>/gi,'');
		s=s.replace(/<\?xml.+?\/>/gi,'');
		d.body.innerHTML=s;
	};
	//增或减高度
	$.changeHeight=function(delta){
		var h=parseInt($.config.height,10);
		if(delta>0 && h>2000 || delta<0 && h<=Math.abs(delta)) return;
		h += delta;
		if(h<50) h=50;
		$.config.height=h+'px';
		$._editorObj().style.height= $.config.height;
		if('visual'==$.currentMode()){
			h-=6;//$._editorObj().offsetHeight-5;
			$._getDoc().body.style.minHeight=h+'px';
			if(isIE6) $._getDoc().body.style.height=h+'px';
		}
	};
	$._fixFull=function(){
		var d=TQE._doc;
		var e=$._containerDiv;
		e.style.zIndex='10000';
		e.style.width=(d.clientWidth-2) + 'px';
		e.style.top = TQE._docScrollTop()+'px';
		e.style.left = TQE._docScrollLeft()+'px';

		e=$._editorObj();
		var h= d.clientHeight-$._toolbarDiv.offsetHeight;
		if('visual'==$.currentMode()){
			e.style.height= h-2 + 'px';
			d = $._getDoc();
			if(d.body){
				h-=6;
				d.body.style.minHeight=h+'px';
				if(isIE6) d.body.style.height=h+'px';
			}
			e.style.width='';
		}else{
			e.style.width=(d.clientWidth-6)+'px';
			e.style.height= h-7 + 'px';
		}
	};
	$._button=function(name){
		var btns = TQE._tags($._toolbarDiv,'LI');
		for(var i=btns.length-1;i>=0;i--){
			if(name==btns[i].getAttribute('name') ) {//	
				return btns[i];
			}
		}
		return null;
	};
	$.fullScreen=function(b){
		var e=$._containerDiv;
		if(b===undefined || null===b){
			b = (e.style.position!='absolute');
		}else{
			if(b == (ec.style.position=='absolute'))return;
		}
		var needFix= 'visual'==$.currentMode();
		if(needFix){
			var code=$.content(false);
		}
		if(b){
			document.body.parentNode.style.overflow = 'hidden';
			//if(needFix)$.changeMode('code');//IE9中,可视化模式时下面这一会导至页面崩溃,所在要切换模式
			e.parentNode.removeChild(e);
			document.body.appendChild(e);
			//if(needFix)$.changeMode('visual');
			if(needFix) $.setContent(code);
			e.style.position='absolute';
			e.style.top = '0px';
			$._fixFull();
			TQE.addListener(window,'resize',$._fixFull);

		}else{
			document.body.parentNode.style.overflow = 'auto';
			TQE.delListener(window,'resize',$._fixFull);
			e.style.position='';
			e.style.width=$.config.width;
			
			var o=$._editorObj();
			if('code'==$.currentMode())o.style.width=e.offsetWidth-6+'px';
			o.style.height=$.config.height;

			//if(needFix)$.changeMode('code');
			e.parentNode.removeChild(e);
			$.obj.parentNode.insertBefore(e,$.obj);
			//if(needFix)$.changeMode('visual');
			if(needFix) $.setContent(code);
			if(needFix){//'visual'==$.currentMode()
				var d = $._getDoc();
				var h=Math.max(o.offsetHeight-6,50);
				d.body.style.minHeight=h+'px';
				if(isIE6) d.body.style.height=h+'px';
			}
			e.scrollIntoView(false);
		}
		if(needFix){
			$._changed();
			$._hook();
		}
		TQE._hideContext();

		//更新全屏按钮图标
		var btn=$._button('fullscreen');
		if(btn){
			btn.style.backgroundPositionX = b ? '-988px' : '-968px';
		}
	};
	$.setContent=function(code){
		//code = ('code'==$.currentMode())? changeAsUbb(code):	changeAsHtml(code);
		if('code'==$.currentMode()){
			var o=$._editorObj();
			o.value=code;
			o.style.padding='2px';
			return;
		}
		if('visual'==$.currentMode()){
			if((isGecko || isOpera) && '<br>'==code.substring(0,4)){
				code=code.substr(4); // 怪怪的Firefox
			}
			if(isGecko) code = code.replace(/<td([^>]*)>\s*<\/td/ig, '<td$1 ><br></td');
			var s='<!DOCTYPE html><html><head><style>\nbody{border:none;height:100%;margin:0;padding:2px;overflow:auto;';//
			if($.config.bgColor || $.config.textColor){
				if($.config.bgColor) s+='background-color:'+$.config.bgColor+';';
				if($.config.textColor) s+='color:'+$.config.textColor+';';
			}
			s +='}\nimg{cursor:default;}\n.splitPage{display:block;width:98%;border-top:#999 1px solid;border-bottom:#999 1px solid;background:#FFFFFF; color:#000000;font-weight:bold;text-align:center;margin:30px auto 5;padding-top:30px;clear:both;}\n.splitPage:before{content:"分页标题:";}</style>\n';
			if ($.config.css) {
				s += '<link href="' +$.config.css+ '" rel="stylesheet" type="text/css">\n';
			}
			s+='</head><body contenteditable="true" >'+ code+'</body></html>';// 
			var d = $._getDoc();
			d.open();
			d.write(s);
			d.close();
			var h=$._editorObj().offsetHeight-6;
			d.body.style.minHeight=h+'px';
			if(isIE6) d.body.style.height=h+'px';
			//d.designMode='On';
		}
	};
	$.setOpacity=function(e, opacity) {
		if (isIE) {
			e.style.filter = (opacity == 100) ? '' : 'gray() alpha(opacity=' + opacity + ')';
		} else {
			e.style.opacity = (opacity == 100) ? '' : opacity/100;
		}
    };
	$.inArray=function(e,arr){
		for(var i=arr.length-1;i>=0;i--) if(e==arr[i]) return true;
		return false;
	};
	$.content=function(formatHTML){
		var m=$.currentMode();
		if('visual'===m){
			var code= $._getDoc().body.innerHTML;
			if((isGecko || isOpera) && '<br>'==code.substring(0,4)) code=code.substr(4);//怪怪的Firefox
		}else{
			code= $._editorObj().value;
		}
		return (formatHTML )? $.formatHTML(code) : code;
	};
	$._autoSave=function(){
		var e = $._editorObj();
		if (isIE ){
			TQE.addListener(e,'beforedeactivate',$.save);
		}else if('code'==$.currentMode()){ 
			TQE.addListener(e,'blur',$.save);
		}else{
			TQE.addListener(e.contentWindow,'blur',$.save);
		}
	};
	$.save=function(){
		$.obj.value=$.content($.config.formatHTML);
	};
	$._intEdit=function(obj){
		if(obj.isIniEdit)return;
		obj.isIniEdit=true;
		obj.style.imeMode='disabled';
		obj.onkeypress=function(){if(45==event.keyCode){this.value = ('-'==this.value.charAt(0))? this.value.substr(1) : '-'+this.value; return false; }return event.keyCode>=48&&event.keyCode<=57;};
		obj.onpaste=function(){return !clipboardData.getData('text').match(/\D/);};
		obj.ondragenter=function(){return ! /\D/.test(event.dataTransfer.getData('text'));};
		obj.oldBlur=obj.onblur;
		obj.onblur=function(){if(''==this.value) return; this.value=parseInt(this.value,10);var max = this.getAttribute('max'); var min= this.getAttribute('min');if(max!=undefined && parseInt(this.value,10)>parseInt(max,10))this.value=parseInt(max,10);if(min!=undefined && parseInt(this.value,10)<parseInt(min,10))this.value=parseInt(min,10); if(this.oldBlur)this.oldBlur();};
	};
	$.formatHTML=function(str){
		var remainInStr=str, outStr='';
		var ubbReg= new RegExp('\\s*(<(\\/?)([a-z]\\w*)[^>]*>)[\\r\\n]*','im');
		var indentChars=[];
		var wrapOutTags={'table':1,'tbody':1,'thead':1,'tfoot':1,'tr':1,'td':1,'p':1,'caption':1,'div':1,'object':1,'param':1,'embed':1,'dl':1,'dd':1,'dt':1,'ul':1,'ol':1,'li':1,'hr':1,'script':1};
		var indentTags={'table':1,'tbody':1,'thead':1,'tfoot':1,'tr':1,'object':1,'dl':1,'ul':1,'ol':1,'div':1,'script':1};
		var embedTags={'a':1,'u':1,'i':1,'b':1,'strong':1,'em':1,'font':1,'span':1,'img':1,'input':1,'h1':1,'h2':1,'h3':1,'h4':1,'h5':1,'h6':1};//保持不变的标签
		while( null != (result = ubbReg.exec(remainInStr))){
			var text = remainInStr.substr(0, result.index);
			var tagExt=	result[0];
			var tagFull=result[1];
			var isEndTag = '/'===result[2];
			var tagName=result[3].toLowerCase();

			remainInStr = remainInStr.substr(result.index + tagExt.length);
			outStr += text;
			if(isEndTag){
				if(indentTags[tagName]) indentChars.pop();
				if(embedTags[tagName]) outStr += tagExt; 
				else if(indentTags[tagName]) outStr +="\n"+indentChars.join('')+tagFull;
				else outStr += tagFull ;

				if(wrapOutTags[tagName]) outStr+="\n"; 
			}else{
				if(wrapOutTags[tagName]) outStr+="\n"; 
				if(embedTags[tagName]) outStr += tagExt; 
				else if(indentTags[tagName]) outStr += indentChars.join('')+tagFull+"\n";
				else outStr += indentChars.join('')+tagFull;
				if('hr'===tagName || 'br'===tagName) outStr+="\n"; 
				if(indentTags[tagName]) indentChars.push('  ');
			}
		}
		outStr += remainInStr;
		outStr = outStr.replace(/\n+/g, "\n").replace(/<td([^>]*)>\s+<br/ig, "<td$1 ><br").replace(/<br>\s+<\/td>/ig, "<br></td>");
		return outStr;
	};
	//------------执行初始化
	if(!isIE6){
		$.init();
	}else{
		var _topTableNode=function(node){
			var  reault=null;
			while(node){
				 if(node.tagName=='TABLE'){
					reault=node;
				 }
				 node = node.parentNode;
			}
			return reault;
		}
		var t= _topTableNode(document.scripts(document.scripts.length-1))
		if(t && _topTableNode(TQE.find(objId))===t ){
			window.setTimeout($.init,8);
		}else{
			$.init();
		}
	}
}
TQE.url='./';//编辑器相关资源网址
TQE.version='2.0.0 beta2'; //编辑器版本
//-- init TQE resources
if(TQE.url==='./'){
	if(!document.scripts) document.scripts =TQE._tags(document,'SCRIPT'); //firefox
	var tqJSUrl = document.scripts[document.scripts.length-1].src;
	TQE.url = tqJSUrl.substring(0,tqJSUrl.toLowerCase().indexOf('tqeditor.'));
	document.write('<link href="'+TQE.url+'TQEditor.css" rel="stylesheet" type="text/css" />');
}
//配置
TQE.config={
	"paragraphs" : [
		["Paragraph",	"p"],
		["Headword 1",	"h1"],
		["Headword 2",	"h2"],
		["Headword 3",	"h3"],
		["Headword 4",	"h4"],
		["Headword 5",	"h5"],
		["Headword 6",	"h6"],
		["预定义",	"pre"]
		],
	"fontnames" : [
		["宋体",            "宋体"],
		["新宋体",          "新宋体"],
		["仿宋_GB2312",     "仿宋_GB2312"],
		["黑体",            "黑体"],
		["微软雅黑",        "微软雅黑"],
		["楷体_GB2312",     "楷体_GB2312"],
		["Arial",           "arial, helvetica, sans-serif"],
		["Courier New",     "courier new, courier, mono"],
		["Georgia",         "Georgia, Times New Roman, Times, Serif"],
		["Tahoma",          "Tahoma, Arial, Helvetica, sans-serif"],
		["Times New Roman", "times new roman, times, serif"]
		],
	"fontsizes": [
		//[text,preview,	value]
		["xx-small","xx-small",	1],
		["x-small","x-small",	2],
		["small",	"small",	3],
		["medium",	"medium",	4],
		["large",	"large",	5],
		["x-large","x-large",	6],
		["xx-large","xx-large",	7]
		],
	"toolbar":'default',
	"toolbarRight":[],
	'showToolbarGroupHandle':true, //显示工具组最前的图
	
	//模板
	//插入媒体***时的模板代码,
	//flash	宏 {$url} {$width} {$height}
	'tplFlash':'<embed src="{$url}" width="{$width}" height="{$height}" quality="high" pluginspage="http://www.macromedia.com/go/getflashplayer" type="application/x-shockwave-flash" wmode="transparent" allowscriptaccess="always"></embed>',
	//flv视频 宏 {$url} {$width} {$height} {$auto_start}
	'tplFlv':'<embed src="'+TQE.url+'flvPlayer.swf" flashvars="vcastr_file={$url}" width="{$width}" height="{$height}" quality="high" bgcolor="#0E0E0E" name="play" align="middle" allowscriptaccess="sameDomain" allowfullscreen="true" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" wmode="opaque" />',
	//rm视频 宏 {$url} {$width} {$height} {$auto_start}
	'tplRm':'<embed src="{$url}" width={$width} height={$height} autostart="{$auto_start}"type="audio/x-pn-realaudio-plugin" console="Clip1" controls="ImageWindow" ></embed>',
	//windows的媒体文件 宏 {$url} {$width} {$height} {$auto_start}
	'tplVideo':'<object id="tqeVP"  classid="clsid:6BF52A52-394A-11d3-B153-00C04F79FAA6"  type="application/x-ms-wmp" width="{$width}" height="{$height}"><PARAM NAME="URL" VALUE="{$url}" /><PARAM NAME="autoStart" VALUE="{$auto_start}" /><PARAM NAME="invokeURLs" VALUE="false"><PARAM NAME="playCount" VALUE="100"><PARAM NAME="Volume" VALUE="100"><PARAM NAME="defaultFrame" VALUE="datawindow"></object>',
	//音乐播放 宏 {$url} {$auto_start} 
	'tplMusic':'<object id="tqeMP"  classid="clsid:6BF52A52-394A-11d3-B153-00C04F79FAA6"  type="application/x-ms-wmp" width="230" height="64"><PARAM NAME="URL" VALUE="{$url}" /><PARAM NAME="autoStart" VALUE="{$auto_start}" /><PARAM NAME="invokeURLs" VALUE="false"><PARAM NAME="playCount" VALUE="100"><PARAM NAME="Volume" VALUE="100"><PARAM NAME="defaultFrame" VALUE="datawindow"></object>',
	//分页符代码
	'tplSplitPage':'<h3 class="splitPage" name="split_page" ></h3>',

	'uploadFieldName':'file',//接收上传时的上传表单名

	'imageUploadUrl':'',//接收上传图片网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
	'imageFileTypes':'*.jpg;*.gif;*.png;*.jpeg',//允许上传的图片后缀
	'imageFileSize':'2MB',//允许上传文件大小
	'directInsertUploadImage':true,//直接将上传的图片插入编辑器中
	
	'linkUploadUrl':'',//接收上传网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
	'linkFileTypes':'*.*',//允许上传的后缀
	'linkFileSize':'2MB',//允许上传文件大小

	'flashUploadUrl':'',//接收上传Flash网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
	'flashFileTypes':'*.swf',//允许上传的图片后缀
	'flashFileSize':'2MB',//允许上传文件大小

	'musicUploadUrl':'',//接收上传音频文件网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
	'musicFileTypes':'*.mp3;*.wma',//允许上传音频文件后缀
	'musicFileSize':'2MB',//允许上传文件大小

	'videoUploadUrl':'',//接收上传视频文件网址, 留空表示不允许上传, 以#开头, 表示点击上传按扭后的界面网址
	'videoFileTypes':'*.flv;.mp4;*.mkv;*.wmv;*.asf;*.avi;*.rmvb;*.rm',//允许上传的文件后缀
	'videoFileSize':'2MB',//允许上传文件大小

	'enter2br':false,
	'formatHTML':true,//对HTML源码进行美化(换行与缩进)
	//'height_delta':20,
	'width':'auto',
	'height':'auto',
	'autoClean':true,//在执行粘贴时,自动清理word相关的垃圾代码
	'faceCount':55,//表情数量, 在face目录中
	'css':'',//设计辅助的相关样式网址
	'bgColor':'',  //可视化编辑时, 编辑器背景色
	'textColor':'',	//可视化编辑时, 文字色

	'typesetImageTextCenter':true,//自动排版图片下方的文字居中
	'typesetIndentParagraph':false,//自动排版段落首行缩进2字
	'typesetImageBorder':true,//自动排版图片添边框


	'debug':false
};

TQE.find=function(id){return document.getElementById(id);};
TQE.CE=function(tag,id, htm, append){
	var o=document.createElement(tag);
	if(id)o.id=id;
	if(htm)o.innerHTML=htm;
	if(append) document.body.appendChild(o);
	return o;
};
TQE.loadSkin=function(skin){
	var e = document.getElementById('TQEditorSkinCSS');
	if(e){
		e.href=TQE.url+'TQEditor.'+skin+'.css';
		return;
	}
	e=document.createElement('LINK');
	e.id='TQEditorSkinCSS';
	e.href=TQE.url+'TQEditor.'+skin+'.css';
	e.rel='stylesheet';
	e.type='text/css';
	document.documentElement.firstChild.appendChild(e);
};
TQE._doc=(document.compatMode != "CSS1Compat") ? document.body : document.documentElement;
TQE._docScrollTop=function(){
	return isIE || isOpera ? TQE._doc.scrollTop : window.scrollY;
};
TQE._docScrollLeft=function(){
	return isIE || isOpera ? TQE._doc.scrollLeft : window.scrollX;
};
TQE.pos=function(e){
	var x = 0;
	var y = 0;
	if (e.getBoundingClientRect) {
		var box = e.getBoundingClientRect();
		var d=TQE._doc;
		x = box.left + TQE._docScrollLeft() - d.clientLeft;
		y = box.top + TQE._docScrollTop() - d.clientTop;
	} else {
		x = e.offsetLeft;
		y = e.offsetTop;
		var parent = e.offsetParent;
		while (parent) {
			x += parent.offsetLeft;
			y += parent.offsetTop;
			parent = parent.offsetParent;
		}
	}
	//if(isWebkit ){//新版已修正
		//x += TQE._docScrollLeft();
		//y += TQE._docScrollTop();
	//}
	return {'x' : x, 'y' : y};
};
TQE._hideContext=function(){
	if(TQE.activeContext){
		TQE.activeContext.style.display="none";
		TQE.activeContext=null;
	}
};

TQE.pop=function(obj,relateObj){
	if(TQE.activePop==obj){
		TQE.hidePop();
		return false;
	}
	TQE._hideContext();
	TQE.hidePop();
	TQE.activePop=obj;
	obj.relateObj=relateObj;
	relateObj.className='eButtonDropDown';

	obj.style.display='block';
	var p=TQE.pos(relateObj);
	var l=p.x;//$._objLeft(relateObj);
	var t= 1+relateObj.clientHeight +p.y;//$._objTop(relateObj);
	var dl = TQE._docScrollLeft();
	var w =  TQE._doc.clientWidth;
	if(l+obj.offsetWidth>dl+w)l-=obj.offsetWidth-relateObj.offsetWidth;
	obj.style.left= l + 'px';
	obj.style.top = t+ 'px';
	return true;
};
TQE.hidePop=function(){
	if(!TQE.activePop) return;
	var o=TQE.activePop;
	TQE.activePop=null;
	o.style.display='none';
	if(o.relateObj && o.relateObj.className=='eButtonDropDown') o.relateObj.className='eButton';
	
	var o=TQE.find('ColorPicker');
	if(o)o.style.display='none';
};
TQE.delListener=function(e,eventName,func){
	if(e.removeEventListener) {
		e.removeEventListener(eventName, func, false );
	}else{
		e.detachEvent('on'+eventName, e['e'+eventName+func]);
	}
};
TQE.addListener=function(e,eventName,func){
	if(e.addEventListener) {
		e.addEventListener( eventName, func, false );
	}else{
		e['fn'+func]=func;
		e['e'+eventName+func]=function(et){e['fn'+func](et)};
		e.attachEvent('on'+eventName, e['e'+eventName+func]);//
	}
};
TQE._tags=function(domNode, tagName){
	return domNode.getElementsByTagName(tagName); 
};
	
TQE.listenTags=function(node,tag,eventname,func){
	var ds = TQE._tags(node,tag);
	for(var i=ds.length-1;i>=0;i--){
		TQE.addListener(ds[i],eventname,func);
	}
};
TQE._noSel=function(o, tagsName){
	var noSel=function(){
		if(isIE){
			var tn=event.srcElement.tagName;
			return 'INPUT'==tn || 'TEXTAREA'==tn;
		}
		return false;
	};
	if(tagsName){
		var a=tagsName.split(',');
		for(var j=a.length-1;j>=0;j--){
			var nodes = TQE._tags(o,a[j]);
			for(var i=nodes.length-1; i>=0;i--){
				nodes[i].unselectable='on';
				nodes[i].onselectstart = noSel
			}
		}
	}else{
		o.unselectable='on';
		o.onselectstart = noSel;
	}
};
TQE._colorPickerUI=function(){
	var ColorHex=['00','33','66','99','CC','FF'];
	var SpColorHex=['FF0000','00FF00','0000FF','FFFF00','00FFFF','FF00FF'];
	var w=191;//1+19*10
	var colorTable='<table width="'+w+'" cellpadding=0 ';
	colorTable += isIE ? 'cellspacing=1 border=0 bgcolor="#000000;">':'cellspacing=0 border=1 style="border-collapse:collapse;" >';
	for (i=0;i<2;i++){
		for (j=0;j<6;j++){
			colorTable += '<tr height=10>';
			//colorTable += '<td bgcolor="#000" name="'+name+'" ></td>';

			if (i>0) colorTable += '<td bgcolor="#'+SpColorHex[j]+'" name="'+name+'"></td>';
			else colorTable += '<td bgcolor="#'+ColorHex[j]+ColorHex[j]+ColorHex[j]+'" ></td>';

			//colorTable += '<td bgcolor="#000"></td>';
			for (k=0;k<3;k++){
				for (l=0;l<6;l++){
					//立方色
					colorTable += '<td bgcolor="#'+ColorHex[k+i*3]+ColorHex[l]+ColorHex[j]+'" ></td>';
					//连续色
					//var c1 = 4+i-k*2;
					//var c2 = i*j + (1-i)*(5-j);// i?j:5-j
					//var c3 = k!=1? 5-l:l;      //k!=1? 5-l:l;
					//colorTable += '<td bgcolor="#'+ColorHex[c1]+ColorHex[c2]+ColorHex[c3]+'"></td>';
				}
			}
			colorTable += '</tr>';
		}
	}
	colorTable +='</table>';
	colorTable +='<div style="padding:2px 2px 1px 2px;line-height:25px;"><div style="height:25px;width:60px;display:block;float:left; margin-right:5px;" name=colorPreview></div><span name="colorValue" style="width:50px; display:inline-block;"></span><input type="button" value="无色" /></div>';
	return colorTable;
};
TQE.pickColor=function(callbackFunc,x,y){
	var o=TQE.find('ColorPicker');
	if(null==o){
		o = TQE.CE('DIV','ColorPicker', TQE._colorPickerUI() ,true);
		o.className='ePopPanel';
		o.style.zIndex=99999999;
		o.onmouseover=function(){this.active=true;};
		o.onmouseout=function(){this.active=false;};

		TQE._noSel(o);//,'TABLE,TR,TD,DIV');
		TQE.listenTags(o,'TD','mouseover',function(){
			var p=this.parentNode.parentNode.parentNode.parentNode.lastChild;
			p.firstChild.style.backgroundColor=this.bgColor;
			p.firstChild.nextSibling.innerHTML=this.bgColor;

			this.style.backgroundColor='#FFFFFF';
			var self=this;
			var iid = window.setInterval(function(){self.style.backgroundColor=(self.style.backgroundColor!='')?'':'#FFFFFF'},500);
			this.onmouseout=function(){window.clearInterval(iid);this.style.backgroundColor='';}
		});
		o.lastChild.lastChild.onclick=function(){this.parentNode.parentNode.style.display='none';};
		TQE.listenTags(o,'TD','mouseup',function(){this.parentNode.parentNode.parentNode.parentNode.style.display='none';});
		TQE.addListener(document,'mousedown',function(){var o=TQE.find('ColorPicker');if(!o.active)o.style.display='none';});
	}
	var ds = TQE._tags(o,'TD');
	for(var i=ds.length-1;i>=0;i--){
		ds[i].onmousedown=function(){callbackFunc(this.bgColor);}
	}
	o.lastChild.lastChild.onclick=function(){callbackFunc('');};

	o.style.left=x+'px';
	o.style.top=y+'px';
	o.style.display='block';
};
TQE.drag=function(o){
	o.style.position='absolute';
	o.onmousedown=function(a){
		var x,y,obj,p=TQE.pos(this),scrollLeft = TQE._docScrollLeft(), scrollTop =TQE._docScrollTop();
		if(isIE){
			a=window.event;
			obj=a.srcElement;
			x=scrollLeft + a.clientX-p.x;
			y=scrollTop + a.clientY-p.y;
		}else{
			obj=a.target;
			x=a.pageX-p.x;
			y=a.pageY-p.y;
		}
		var n=obj.tagName;
		if(obj!=this && ( n=='INPUT' || n=='TEXTAREA'|| n=='BUTTON'|| n=='SELECT')) return;

		if(o.setCapture)
			o.setCapture();
		else if(window.captureEvents)
			window.captureEvents(Event.MOUSEMOVE|Event.MOUSEUP);

		document.onmousemove=function(a){
			if(isIE){
				a=window.event;
				a.pageX=scrollLeft + a.clientX;
				a.pageY=scrollTop + a.clientY;
			}
			var tx=a.pageX-x, ty=a.pageY-y;
			o.style.left=tx +'px';
			o.style.top=ty +'px';
			o.style.cursor='move';
		};

		document.onmouseup=function(){
			if(o.releaseCapture)
				o.releaseCapture();
			else if(window.captureEvents)
				window.captureEvents(Event.MOUSEMOVE|Event.MOUSEUP);
			document.onmousemove=null;
			document.onmouseup=null;
			o.style.cursor='';
		};
	};
};
TQE.clone=function(srcObj){   
    if(typeof(srcObj) != 'object') return srcObj;   
    if(srcObj == null) return srcObj;   
    var newObj = '[object Array]'==Object.prototype.toString.call(srcObj)? [] : {};    
    for(var i in srcObj) newObj[i] = TQE.clone(srcObj[i]);    
    return newObj;   
}; 
TQE.removeNode=function(node, delChild){
	if(node.removeNode) return node.removeNode(delChild); //ie
	if(delChild) return node.parentNode.removeChild(node);
	while(node.firstChild) node.parentNode.insertBefore(node.firstChild,node);
	node.parentNode.removeChild(node);

};
//常用工具栏模式
TQE.toolbarMode={
	admin:{left:['paragraph','fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat','|','justifyleft','justifycenter','justifyright','moreformat',
		'||','createlink','insertimage','inserttable','splitpage','|','insertmusic','insertflash','insertvideo',
		'||','cleanword','typeset'],
		right:['fullscreen','mode','|','help']},
	user:{left:['fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat','|','justifyleft','justifycenter','justifyright','moreformat',
		'||','createlink','insertimage','inserttable','|','insertvideo','|','typeset'],
		right:['fullscreen','mode']},
	mini:{left:['fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat','|','align','|','createlink','insertimage'],
		right:[]},
	message:{left:['insertface','|','fontsize','|','bold','italic','underline','|','forecolor','backcolor','|','removeformat'],
		right:[]},
	full:{left:['paragraph','fontname','fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat',
		'||','align','list','iodent','|','superscript','subscript',
		'||','createlink','unlink','insertimage','inserttable','inserthorizontalrule','splitpage','insertface','|','insertmusic','insertflash','insertvideo',
		'||','cleanword','typeset'],
		right:['fullscreen','mode','|','help']},
	normal:{left:['paragraph','fontsize','|','bold','italic','underline','forecolor','backcolor','removeformat',
		'||','justifyleft','justifycenter','justifyright','moreformat',
		'||','createlink','insertimage','inserttable','|','insertvideo','|','typeset'],
		right:['fullscreen','mode','|','help']}
};
//可用的按钮
TQE.toolbarBottons={
	paragraph:{
		text:'paragraph', 
		width:20, 
		left:935,
		click:function($,sender){
			var o=TQE.find($.objId+'Paragraph');
			if(null==o){
				var s='',fs=$.config.paragraphs;
				for(var i=0;i < fs.length; i++){
					s +='<div name="FormatBlock" class="eMenuItem" unselectable=on onselectstart="return false" paraValue="'+fs[i][1]+'">'+fs[i][0]+'</div>';
				}
				o = TQE.CE('DIV',$.objId+'Paragraph',s,true);
				o.className='ePopPanel';
				TQE._noSel(o);//,'DIV'
				TQE.listenTags(o,'DIV','click',function(){
					TQE.hidePop();
					var pv=this.getAttribute('paraValue');
					if(isIE)pv ='<'+pv+'>';
					$.exeCmd('FormatBlock', pv);
				});
				if(isIE6){ 
					var es = TQE._tags(o,'DIV');
					for(var i=es.length-1;i>=0;i--){
						$._ieMouseStyle(es[i],'eMenuItem','eMenuItemUp','eMenuItem');
					}
				}
			}
			TQE.pop(o,sender);
		}
	},
	
	fontsize:{
		text:'fontsize', 
		width:20, 
		left:81,
		click:function($,sender){
			var o=TQE.find($.objId+'FontSize');
			if(null==o){
				var s='',fs=$.config.fontsizes;
				for(var i=0;i < fs.length; i++){
					s +='<div name="FontSize" class="eMenuItem" unselectable=on onselectstart="return false" paraValue="'+fs[i][2]+'" style="font-size:'+fs[i][1]+';" >'+fs[i][0]+'</div>';
				}
				o = TQE.CE('DIV',$.objId+'FontSize',s,true);
				o.className='ePopPanel';
				TQE._noSel(o);//,'DIV'
				TQE.listenTags(o,'DIV','click',function(){TQE.hidePop();$.exeCmd('FontSize', this.getAttribute('paraValue'))});
				if(isIE6){ 
					var es = TQE._tags(o,'DIV');
					for(var i=es.length-1;i>=0;i--){
						$._ieMouseStyle(es[i],'eMenuItem','eMenuItemUp','eMenuItem');
					}
				}
			}
			TQE.pop(o,sender);
		}
	},
	fontname:{
		text:'fontname', 
		width:20, 
		left:59,
		click:function($,sender){
			var o=TQE.find($.objId+'FontName');
			if(null==o){
				var s='',fs=$.config.fontnames;
				for(var i=0;i < fs.length; i++){
					s +='<div name="FontName" class="eMenuItem" unselectable=on onselectstart="return false"  paraValue="'+fs[i][1]+'"  style="font-family:'+fs[i][1]+';" >'+fs[i][0]+'</div>';
				}
				o = TQE.CE('DIV',$.objId+'FontName',s,true);
				o.className='ePopPanel';
				TQE._noSel(o);//,'DIV'
				TQE.listenTags(o,'DIV','click',function(){TQE.hidePop();$.exeCmd('FontName', this.getAttribute('paraValue'))});
				if(isIE6){ 
					var es = TQE._tags(o,'DIV');
					for(var i=es.length-1;i>=0;i--){
						$._ieMouseStyle(es[i],'eMenuItem','eMenuItemUp','eMenuItem');
					}
				}
			}
			TQE.pop(o,sender);
		}
	},
	forecolor:{
		text:'color', 
		width:20, 
		left:240,
		click:function($,sender){
			$._showColorSelectUI(sender,'forecolor'); 
		}
	},
	backcolor:{
		text:'backcolor', 
		width:20, 
		left:260,
		click:function($,sender){
			$._showColorSelectUI(sender, isIE ? 'BackColor':'HiliteColor');
		}
	},
	bold:{
		text:'bold', 
		width:20, 
		left:0,
		click:null
	},
	italic:{
		text:'italic', 
		width:20, 
		left:20,
		click:null
	},
	underline:{
		text:'underline', 
		width:20, 
		left:39,
		click:null
	},
	strikethrough:{
		text:'strikethrough', 
		width:20, 
		left:722,
		click:null
	},
	removeformat:{
		text:'remove format', 
		width:20, 
		left:700,
		click:null
	},
	moreformat:{
		text:'', 
		width:10, 
		left:957,
		click:function($,sender){
			$._popAsMenu(sender,['orderedlist','unorderedlist','|','indent','outdent','|','superscript','subscript']);
		}
	},
	subscript:{
		text:'subscript', 
		width:20, 
		left:761,
		click:null
	},
	superscript:{
		text:'superscript', 
		width:20, 
		left:742,
		click:null
	},
	align:{
		text:'align', 
		width:20, 
		left:425,
		click:function($,sender){
			$._popAsMenu(sender,['justifyleft','justifycenter','justifyright']);
		}
	},
	justifyleft:{
		text:'justify left', 
		width:20, 
		left:100,
		click:null
	},
	justifycenter:{
		text:'justify center', 
		width:20, 
		left:120,
		click:null
	},
	justifyright:{
		text:'justify right', 
		width:20, 
		left:140,
		click:null
	},
	list:{
		text:'list', 
		width:22, 
		left:447,
		click:function($,sender){ 
			$._popAsMenu(sender,['orderedlist','unorderedlist']); 
		}
	},
	unorderedlist:{
		text:'unordered list', 
		width:20, 
		left:181,
		click:function($,sender){
			TQE.hidePop();
			$.exeCmd('InsertUnorderedList');
		}
	},
	orderedlist:{
		text:'ordered list', 
		width:20, 
		left:161,
		click:function($,sender){
			TQE.hidePop();
			$.exeCmd('InsertOrderedList');
		}
	},
	iodent:{
		text:'indent outdent', 
		width:22, 
		left:469,
		click:function($,sender){
			$._popAsMenu(sender,['indent','outdent'])
		}
	},
	outdent:{
		text:'outdent', 
		width:20, 
		left:201,
		click:null
	},
	indent:{
		text:'indent', 
		width:20, 
		left:221,
		click:null
	},
	inserthorizontalrule:{
		text:'insert horizontal rule', 
		width:20, 
		left:821,
		click:null
	},
	createlink:{
		text:'create link', 
		width:20, 
		left:285,
		click:function($,sender){
			var o=TQE.find($.objId+'CreateLink');
			if(null==o){
				var s='URL:<input type="text" id="url" value="" size=45 /><br />Window:<select id="target"><option value="" >default</option><option value="_blank">new</option><option value="_self">self</option><option value="_parent">parent</option><option value="_top">top</option></select>';
				var okClick= function(){
					TQE.hidePop();
					var es=this.form.elements;
					var href=es['url'].value;
					var target=es['target'].value;
					if('http://'==href || ''==href){
						$.exeCmd('Unlink');
						return;
					}
					$.exeCmd('CreateLink', href);
					var n=$.focusNode();
					do{
						if(n.tagName=='A'){
							if(''==target) n.removeAttribute('target') ;
							else n.setAttribute('target',target);
							break;
						}
					}while(n = n.parentNode);
				};
				o = $._popFormUI($.objId+'CreateLink','Create Link', s, okClick,null, $.config.linkUploadUrl,$.config.linkFileTypes,$.config.linkFileSize,false);
				TQE.drag(o);
			}
			if(!TQE.pop(o,sender)) return;

			var f = TQE._tags(o,'FORM')[0];
			f.reset();
			var es = f.elements;
			var n = $.focusNode();
			do{
				if(n.tagName=='A'){
					es['url'].value=n.getAttribute('href');
					$.__selectOption(es['target'],n.getAttribute('target'));
					break;
				}
			}while(n = n.parentNode);
		}
	},
	unlink:{
		text:'remove link', 
		width:20, 
		left:842,
		click:null
	},
	inserttable:{
		text:'insert table', 
		width:20, 
		left:591,
		click:function($,sender){
			var o=TQE.find($.objId+'InsertTable');
			if(null==o){
				var s='<div>row:<input name="row" type="text" id="row" value="3" size="5" /> col:<input name="col" type="text" id="col" value="5" size="5" /><br />background color:<input name="bgcolor" type="text" id="bgcolor" value="" size="7" /><br />border color:<input name="bordercolor" type="text" id="bordercolor" value="" size="7" /><br />align:<select name="align" id="align"><option value="" >default</option><option value="left">left</option><option value="center">center</option><option value="right">right</option></select><br />width:<input name="width" type="text" id="width" value="100%" size="5" /><br />padding:<input name="cellpadding" type="text" id="cellpadding" value="3" size="5" /></div>';
				var okClick=function(){
					TQE.hidePop();
					var es=this.form.elements;
					var s='<table style="border-collapse:collapse;" border=1 cellspace=0 ';
					if(!isNaN(parseInt(es['cellpadding'].value))) s+=' cellpadding='+parseInt(es['cellpadding'].value);
					if(''!=es['width'].value) s+=' width='+es['width'].value;
					if(''!=es['align'].value) s+=' align='+es['align'].value;
					if(''!=es['bordercolor'].value) s+=' bordercolor='+es['bordercolor'].value;
					if(''!=es['bgcolor'].value) s+=' bgcolor='+es['bgcolor'].value;
					s +='>';
					for(var i=parseInt(es['row'].value);i>0;i--){
						s+'<tr>';
						for(var j=parseInt(es['col'].value);j>0;j--){
							s+=isIE ? '<td></td>':'<td><br /></td>';	//  
						}
						s+='</tr>';
					}
					s+='</table>';
					$.insertHtml(s);
				};
				o = $._popFormUI($.objId+'InsertTable','Insert Table', s, okClick ,['row','col','cellpadding']);
				TQE.drag(o);
				var f= TQE._tags(o,'FORM')[0];
				var es = f.elements;
				es['bordercolor'].onclick=function(){
					var p = TQE.pos(this);
					var l=p.x;//$._objLeft(this);
					var t= 5+this.clientHeight + p.y;//$._objTop(this);
					var obj=this;
					TQE.pickColor(function(color){obj.value=color;},l,t);
				};
				es['bordercolor'].onblur=function(){var o=TQE.find('ColorPicker');if(o)o.style.display='none';};
				es['bgcolor'].onclick= es['bordercolor'].onclick;
				es['bgcolor'].onblur= es['bordercolor'].onblur;
			}
			if(!TQE.pop(o,sender)) return;
			var f = TQE._tags(o,'FORM')[0];
			f.reset();
			//f.elements['row'].focus();
		}
	},
	insertimage:{
		text:'insert image', 
		width:20, 
		left:322,
		click:function($,sender){
			var o=TQE.find($.objId+'InsertImage');
			if(null==o){
				var s='URL:<input type="text" id="url" value="" size=40 /><br />alt:<input name="alt" type="text" id="alt" size="20" /><br />size:<input name="width" type="text" id="width" size="4" /> &times; <input name="height" type="text" id="height" size="4" /> px &nbsp;<br />align:<select name="align" id="align"><option value="" >default</option><option value="top">top</option><option value="textTop">text top</option><option value="middle">middle</option><option value="absMiddle">absMiddle</option><option value="baseline">baseline</option><option value="bottom">bottom</option><option value="absBottom">absBottom</option><option value="left">left</option><option value="right">right</option></select> &nbsp; &nbsp; border:<input name="border" type="text" id="border" size="5" />';
				var okClick=function(){
					TQE.hidePop();
					var es=this.form.elements;
					$.insertImage(es['url'].value,es['width'].value,es['height'].value,es['border'].value, es['alt'].value,es['align'].value);
					};
				o = $._popFormUI($.objId+'InsertImage','Insert Image', s, okClick ,['width','height','border'], $.config.imageUploadUrl,$.config.imageFileTypes, $.config.imageFileSize, true);
				TQE.drag(o);
			}
			if(!TQE.pop(o,sender)) return;
			var f = TQE._tags(o,'FORM')[0];
			f.reset();
			var es = f.elements;
			var r=$._getRange();
			var n=r.commonAncestorContainer;
			if(n){ //标准dom
				if(isIE9){
					if(r.startContainer.length == r.startOffset && r.endOffset==0 && r.startContainer.nextSibling==r.endContainer.previousSibling){
						n=r.startContainer.nextSibling;
					}
				}else if(!r.collapsed && r.startContainer == r.endContainer && r.startOffset - r.endOffset < 2 && r.startContainer.hasChildNodes()){
					n=r.startContainer.childNodes[r.startOffset];
				}
				if(n.tagName!='IMG') n=null; 
			}else if(r.length && r.item(0).tagName=='IMG'){	//isIE, ie6,7,8
				n=r.item(0);
			}
			if(n && 'IMG'==n.tagName){
				 es['url'].value=n.getAttribute('src');
				 es['width'].value=n.width;
				 es['height'].value=n.height;
				 es['border'].value=n.border;
				 es['alt'].value=n.alt;
				 $.__selectOption(es['align'],n.align);
			}
		}
	},
	insertface:{
		text:'face', 
		width:20, 
		left:362,
		click:function($,sender){
			var o=TQE.find($.objId+'InsertFace');
			if(null==o){
				var s='<div class="eFace">';
				for(var i=1;i<=$.config.faceCount;i++){
					s+='<img src="'+TQE.url+'face/'+i+'.gif" emot="'+i+'" />';
				}
				s+='</div>';
				o = TQE.CE('DIV',$.objId+'InsertFace', s ,true);
				o.className='ePopPanel';
				TQE._noSel(o);//,'IMG,DIV'); 
				TQE.listenTags(o,'IMG','click',function(){TQE.hidePop();$.insertHtml('<img align=absMiddle src="'+this.src+'" emot="'+this.getAttribute('emot')+'" />');});
				if(isIE6){ 
					var es = TQE._tags(o,'IMG');
					for(var i=es.length-1;i>=0;i--){
						$._ieMouseStyle(es[i],'','imgHover','');
					}
				}
			}
			TQE.pop(o,sender);
		}
	},
	insertflash:{
		text:'insert Flash', 
		width:20, 
		left:530,
		click:function($,sender){
			var o=TQE.find($.objId+'InsertFlash');
			if(null==o){
				var s='Flash网址:<input type="text" id="url" value="" size=40 /><br />尺寸:<input name="width" type="text" id="width" size="4" value="200" />&times;<input name="height" type="text" id="height" size="4" value="200" /> px';

				var okClick= function(){
					TQE.hidePop();
					var es=this.form.elements;
					$.insertFlash(es['url'].value,es['width'].value,es['height'].value);
				};
				o = $._popFormUI($.objId+'InsertFlash','Insert Flash', s, okClick,['width','height'], $.config.flashUploadUrl,$.config.flashFileTypes,$.config.flashFileSize, false);
				TQE.drag(o);
			}
			if(!TQE.pop(o,sender)) return;
			var f = TQE._tags(o,'FORM')[0];
			f.reset();
		}
	},
	insertmusic:{
		text:'insert music', 
		width:20, 
		left:491,
		click:function($,sender){
			var o=TQE.find($.objId+'InsertMusic');
			if(null==o){
				var s='URL:<input type="text" id="url" value="" size=40 /><br />autostart:<select id="auto_start" name="auto_start"><option value="0">no</option><option value="1">yes</option></select>';
				var okClick= function(){
					TQE.hidePop();
					var es=this.form.elements;
					$.insertMusic(es['url'].value,es['auto_start'].value);
				};
				o = $._popFormUI($.objId+'InsertMusic','Insert Music', s, okClick,null, $.config.musicUploadUrl,$.config.musicFileTypes,$.config.musicFileSize, false);
				TQE.drag(o);
			}
			if(!TQE.pop(o,sender)) return ;
			var f = TQE._tags(o,'FORM')[0];
			f.reset();
		}
	},
	insertvideo:{
		text:'insert video', 
		width:20, 
		left:1029,
		click:function($,sender){
			var o=TQE.find($.objId+'InsertVideo');
			if(null==o){
				var s='URL:<input type="text" id="url" value="" size=40 /><br />size:<input name="width" type="text" id="width" size="4"  value="320"/>&times;<input name="height" type="text" id="height" size="4" value="240" /> px<br />autostart:<select id="auto_start" name="auto_start"><option value="0">no</option><option value="1">yes</option></select><br />type:<select id="video_type" name="video_type"><option value="auto">auto detect</option><option value="flv">FLV</option><option value="rm">RMVB</option><option value="wm">window video</option></select>';
				var okClick= function(){
					TQE.hidePop();
					var es=this.form.elements;
					$.insertVideo(es['url'].value,es['auto_start'].value,es['width'].value,es['height'].value,es['video_type'].value);
				};
				o = $._popFormUI($.objId+'InsertVideo','Insert Video', s, okClick,['width','height'], $.config.videoUploadUrl,$.config.videoFileTypes,$.config.videoFileSize, false);
				TQE.drag(o);
			}
			if(!TQE.pop(o,sender)) return;

			var f = TQE._tags(o,'FORM')[0];
			f.reset();
			//f.elements['url'].focus();
		}
	},
	cleanword:{
		text:'clean useless code ', 
		width:20, 
		left:611,
		click:function($,sender){
			TQE.hidePop();
			$.cleanWord(true);
		}
	},
	typeset:{
		text:'auto typeset', 
		width:20, 
		left:1170,
		click:function($,sender){
			TQE.hidePop();
			$.typeset();
		}
	},
	mode:{
		text:'mode', 
		width:20, 
		left:631,
		click:function($,sender){
			TQE.hidePop(); 
			$.changeMode();
		}
	},
	splitpage:{
		text:'insert page break', 
		width:20, 
		left:652,
		click:function($,sender){ 
			TQE.hidePop(); 
			$.insertHtml($.config.tplSplitPage,'after');
		}
	},
	group:{
		text:'', 
		width:7, 
		left:309,
		click:null
	},
	separator:{
		text:'', 
		width:5, 
		left:315,
		click:null
	},

	fullscreen:{
		text:'fullscreen', 
		width:20, 
		left:968,
		click:function($,sender){
			TQE.hidePop();
			$.fullScreen();
		}
	},
	help:{
		text:'about', 
		width:20, 
		left:912,
		click:function($,sender){
			var o=TQE.find($.objId+'TQHelpPanel');
			if(null==o){
				var s='<form class="ePopForm" style="line-height:20px;">TQEditor<br/>Version: '+TQE.version+'<br/>Author: TengQiu Lee<br/>Site: <a href="http://www.e512.net" target="_blank">e512.net</a><br />Email: <a href="mailto:litqqs@163.com">litqqs@163.com</a><br /><a href="tencent://message/?uin=7775038&Site=e512.net&Menu=no" style="clear:both;"><span class="eButton" style="background-position: -1050px 0;width:20px;" ></span> 7775038</a></form>';
				o = TQE.CE('DIV',$.objId+'TQHelpPanel', s ,true);
				o.className='ePopPanel';
			}
			TQE.pop(o,sender);
		}
	}
};


var tqEditor=TQE;
var tqeditor=TQE;
var TQEditor=TQE;
